namespace CMSMicroservice.Application.UserAddressCQ.Commands.UpdateUserAddress;
public class UpdateUserAddressCommandValidator : AbstractValidator<UpdateUserAddressCommand>
{
    public UpdateUserAddressCommandValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
     
        RuleFor(model => model.Title)
            .NotEmpty();
        RuleFor(model => model.Address)
            .NotEmpty();
        RuleFor(model => model.PostalCode)
            .NotEmpty();
        RuleFor(model => model.IsDefault)
            .NotNull();
        RuleFor(model => model.CityId)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateUserAddressCommand>.CreateWithOptions((UpdateUserAddressCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
